'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

/** Components */

var _reactBootstrap = require('react-bootstrap');

var _zxcvbn = require('zxcvbn');

var _zxcvbn2 = _interopRequireDefault(_zxcvbn);

if (process.env.BROWSER) {
  require('styles/password-estimator.scss');
}

var Labels = ['Weak', 'Normal', 'Medium', 'Strong', 'Very Strong'];
var ClassNames = ['danger', 'warning', 'primary', 'success', 'success'];

var PasswordInput = (function (_Component) {
  _inherits(PasswordInput, _Component);

  function PasswordInput(props, context) {
    _classCallCheck(this, PasswordInput);

    _get(Object.getPrototypeOf(PasswordInput.prototype), 'constructor', this).call(this, props, context);
    this.state = this.getInitState();
  }

  _createClass(PasswordInput, [{
    key: 'getInitState',
    value: function getInitState() {
      return {
        score: null,
        warning: null,
        suggestions: []
      };
    }
  }, {
    key: 'scoreToLabel',
    value: function scoreToLabel() {
      if (Number.isInteger(this.state.score)) {
        return Labels[this.state.score];
      } else {
        return '';
      }
    }
  }, {
    key: 'scoreToClass',
    value: function scoreToClass() {
      if (Number.isInteger(this.state.score)) {
        return ClassNames[this.state.score];
      } else {
        return 'default';
      }
    }
  }, {
    key: 'scoreToPercentage',
    value: function scoreToPercentage() {
      if (Number.isInteger(this.state.score)) {
        return (this.state.score + 1) * 20;
      } else {
        return 0;
      }
    }
  }, {
    key: 'checkPassword',
    value: function checkPassword(e) {
      var password = e.target.value;
      if (password === '') {
        this.setState(this.getInitState());
        return;
      }
      var result = (0, _zxcvbn2['default'])(password);
      var newState = {
        score: result.score,
        label: this.scoreToLabel(result.score),
        warning: result.feedback.warning,
        suggestions: result.feedback.suggestions
      };
      this.setState(newState);
    }
  }, {
    key: 'renderWarning',
    value: function renderWarning() {
      if (this.state.warning) {
        return _react2['default'].createElement(
          _reactBootstrap.Alert,
          { bsStyle: 'warning' },
          _react2['default'].createElement('i', { className: 'fa fa-exclamation-triangle' }),
          ' ',
          this.state.warning
        );
      }
    }
  }, {
    key: 'renderSuggestions',
    value: function renderSuggestions() {
      if (this.state.suggestions && this.state.suggestions.length > 0) {
        var suggestions = this.state.suggestions.map(function (suggestion, count) {
          return _react2['default'].createElement(
            'p',
            { key: count },
            _react2['default'].createElement('i', { className: 'fa fa-info-circle' }),
            ' ',
            suggestion
          );
        });
        return _react2['default'].createElement(
          _reactBootstrap.Alert,
          { bsStyle: 'info' },
          suggestions
        );
      }
    }
  }, {
    key: 'render',
    value: function render() {
      return _react2['default'].createElement(
        'div',
        { className: 'password-estimator' },
        _react2['default'].createElement(_reactBootstrap.Input, { type: 'password',
          ref: 'password',
          className: 'form-control',
          placeholder: 'Password',
          onChange: this.checkPassword.bind(this),
          required: true }),
        _react2['default'].createElement(_reactBootstrap.ProgressBar, { striped: this.state.score === 4,
          bsSize: 'xs',
          bsStyle: this.scoreToClass(),
          now: this.scoreToPercentage(),
          label: this.scoreToLabel() }),
        ' ',
        this.renderWarning(),
        ' ',
        this.renderSuggestions()
      );
    }
  }]);

  return PasswordInput;
})(_react.Component);

exports['default'] = Password;
module.exports = exports['default'];